<?php

include("pChart2.1.3/class/pData.class.php");
include("pChart2.1.3/class/pDraw.class.php");
include("pChart2.1.3/class/pImage.class.php");


class MyGraph
{
    var $_db_name;
    var $_db_login;
    var $_db_passw;
    var $_db_table;

    var $_title;
    var $_feeds;
    var $_nbdays;
    var $_type;
    var $_dateformat;

    var $_dataset;
    var $_data;

    function _computeMysql()
    {
        // Liste uniquement les feeds qui m'interessent
        $sql_feeds = "";
        reset($this->_feeds);
        while (list($k, $v) = each($this->_feeds))
        {
            $sql_feeds .= ($sql_feeds == "" ) ? "(" : "OR ";
            $sql_feeds .= 'peripherique=' . $k . ' ';
        }
        $sql_feeds .= ")";

        // Uniquement sur la periode qui m'interesse
        $sql_date = "AND (`date_debut` > DATE_SUB(NOW(), INTERVAL " . floor($this->_nbdays * 24) . " HOUR))";

        // Connecte
        $db = mysqli_connect('localhost', $this->_db_login, $this->_db_passw);
        mysqli_select_db($db, $this->_db_name) or die('Erreur SQL !<br>'.mysqli_error($db));

        // Create query
        $interval = $this->_computeInterval();
        $sql  = 'SELECT ' . $this->_type . '(valeur) AS computed, peripherique, UNIX_TIMESTAMP(date_debut) AS utimestamp';
        $sql .= ' FROM ' . $this->_db_table . ' WHERE ' . $sql_feeds . " " . $sql_date;
        $sql .= ' GROUP BY FLOOR(utimestamp / ' . $interval . '), peripherique;';

        // Execute query
        $req = mysqli_query($db, $sql) or die('Erreur SQL !<br>' . $sql . '<br>' . mysqli_error($db));

        // aggrate datas
        $this->_dataset = array();
        while($data = mysqli_fetch_assoc($req))
        {
            $this->_dataset[$data['peripherique']]["value"][] = floor(($data['computed'] * 1000)) / 1000;

            $t = date($this->_dateformat, $data['utimestamp']);
            $this->_dataset[$data['peripherique']]["time"][] = $t;
        }
        
        //echo ("<pre>" . $sql . "<br><br>"); print_r($this->_dataset);
        //exit ();
    }

    function _computeInterval()
    {
        //return $this->_nbdays * 3600; // interval in hour.
        if ($this->_nbdays <= 1) return 3600 * $this->_nbdays; // Every hours
        if ($this->_nbdays <= 7) return 3600 * 12 * ($this->_nbdays / 7); // Every 6 hours
        if ($this->_nbdays <= 31) return 3600 * 24 * ($this->_nbdays / 31); // Every days
        if ($this->_nbdays <= 365) return 3600 * 24 * 31 * ($this->_nbdays / 365); // Every month
    }

    function _addData($name)
    {
        $this->_data->addPoints($this->_dataset[$name]["value"], $name);
        $this->_data->setSerieDescription($name, $this->_feeds[$name]);
        $this->_data->setSerieOnAxis($name, 0);
        $this->_data->setSerieWeight($name, 1);
    }

    function _computeGraph($width, $height)
    {
        $this->_data->setAxisPosition(0,AXIS_POSITION_LEFT);
        $this->_data->setAxisName(0,$this->_title);
        $this->_data->setAxisUnit(0,"");

        $picture = new pImage($width,$height,$this->_data,TRUE);

        $settings = array("R"=>170, "G"=>183, "B"=>87, "Dash"=>1, "DashR"=>190, "DashG"=>203, "DashB"=>107);
        $picture->drawFilledRectangle(0,0,$width,$height,$settings);

        $settings = array("StartR"=>219, "StartG"=>231, "StartB"=>139, "EndR"=>1, "EndG"=>138, "EndB"=>68, "Alpha"=>50);
        $picture->drawGradientArea(0,0,$width,$height,DIRECTION_VERTICAL,$settings);

        $picture->drawRectangle(0,0,$width - 1,$height - 1,array("R"=>0,"G"=>0,"B"=>0));

        $picture->setFontProperties(array("FontName"=>"pChart2.1.3/fonts/Forgotte.ttf","FontSize"=>14));
        $textSettings = array("Align"=>TEXT_ALIGN_MIDDLEMIDDLE, "R"=>255, "G"=>255, "B"=>255);
        $picture->drawText($width / 2, 25,$this->_title,$textSettings);

        $picture->setGraphArea(30,60,$width - 25, $height - 30);
        $picture->setFontProperties(array("R"=>0,"G"=>0,"B"=>0,"FontName"=>"pChart2.1.3/fonts/pf_arma_five.ttf","FontSize"=>6));

        $settings = array("Pos"=>SCALE_POS_LEFTRIGHT, "Mode"=>SCALE_MODE_FLOATING, "LabelingMethod"=>LABELING_ALL,
                          "GridR"=>255, "GridG"=>255, "GridB"=>255, "GridAlpha"=>50, "TickR"=>0, "TickG"=>0, "TickB"=>0, "TickAlpha"=>50,
                          "LabelRotation"=>0, "CycleBackground"=>1, "DrawXLines"=>1, "DrawSubTicks"=>1,
                          "SubTickR"=>255, "SubTickG"=>0, "SubTickB"=>0, "SubTickAlpha"=>50, "DrawYLines"=>ALL, "LabelSkip"=>1);
        $picture->drawScale($settings);

        $config = array(); //array("DisplayValues"=>1);
        $picture->drawSplineChart($config);

        $Config = array("FontR"=>0, "FontG"=>0, "FontB"=>0, "FontName"=>"pChart2.1.3/fonts/pf_arma_five.ttf", "FontSize"=>6,
                        "Margin"=>6, "Alpha"=>30, "BoxSize"=>5, "Style"=>LEGEND_NOBORDER, "Mode"=>LEGEND_HORIZONTAL);
        $picture->drawLegend($width - 120,15,$config);

        $picture->stroke();
    }

    function __construct($title)
    {
       $this->_db_name  = "historique_eedomus";
       $this->_db_login = "login";
       $this->_db_passw = "passe";
       $this->_db_table = "environnement";

        $this->_title = "Untitled";
        $this->_feeds = array();
        $this->_type = "AVG";

        $this->_dataset = array();
        $this->_data = null;

        $this->_title = $title;

        $this->setWindowTime(1);
    }

    function setFeeds($feeds)
    {
        $this->_feeds = $feeds;
    }

    // $time in days (double)
    function setWindowTime($time)
    {
        $this->_nbdays = $time;

        if ($this->_nbdays <= 365) $this->_dateformat = "m/Y";
        if ($this->_nbdays <= 31) $this->_dateformat = "j/m/Y";
        if ($this->_nbdays <= 7) $this->_dateformat = "j/m/Y\n    H:i";
    }

    function setTypeAvg()
    {
        $this->_type = "AVG";
    }

    function setTypeSum()
    {
        $this->_type = "SUM";
    }

    function compute($width, $height)
    {
        $this->_computeMysql();

        // Add data to graph
        $this->_data = new pData();
        $lastfeed = null;
        reset($this->_feeds);
        while (list($n, $d) = each($this->_feeds))
        {
            $lastfeed = $n;
            $this->_addData($n, $d);
        }
        $this->_data->addPoints($this->_dataset[$lastfeed]["time"], "Absissa");
//        $this->_data->addPoints(str_replace(" ", "\n  ", $this->_dataset[$lastfeed]["time"]), "Absissa");
        $this->_data->setAbscissa("Absissa");

        $this->_computeGraph($width, $height);
    }
}

if (!isset($_GET['feeds'])) die(
"<pre><b>Usage:</b> <i>script.php?title=mytitle&windowtime=7&feeds[feedname1]=feeddesc1&feeds[feedname2]=feeddesc2&feeds[feedname3]=feeddesc3</i>
<b>With:</b>
    <i>title</i> (string) which is the graph name.
    <i>windowtime</i> (double) which is the graph period in days.
    <i>feeds</i> (array) which is an array that contain the feed name as key and the feed description as value.
    <i>type</i> (string) optional parameter that can have 'sum' value to compute sum instead of average.</pre>");


if (isset($_GET['title']))
    $title = $_GET['title'];
else
    $title = "Sans titre";

$myGraph = new MyGraph($title);

$myGraph->setFeeds($_GET['feeds']);

if (isset($_GET['type']) && $_GET['type'] == "sum")
    $myGraph->setTypeSum();

if (isset($_GET['windowtime']))
    $myGraph->setWindowTime($_GET['windowtime']);

if (isset($_GET['width']))
    $width = 0+$_GET['width'];
else $width=640;

if (isset($_GET['height']))
    $height = 0+$_GET['height'];
else $height=480;

$myGraph->compute($width, $height);


?>
